require 'cht-chaphql'
require 'cht-chaphql/graphql_formatters'

SAVINGS_PLANS_FMTRS =
  YAML.load_file(File.join(__dir__, '../helpers/formatters.yml'))

# module for savings-plans
module ChtApitestSavingsPlans
  include Chaphql
  include Chaphql::GraphQLHelpers

  # module for your shortcuts
  module SavingsPlansHelpers
    def lvia_public
      %w{prod staging canary}.include?(getenv)
    end

    def lauth_service
      LocalAuthService.new(via_public: lvia_public)
    end

    # insertion point for shortcuts

    def create_sp_saved_recommendations(args = {})
      args[:service] = SavingsPlansService.new
      sym = first_no_cap(camelize('create_sp_saved_recommendations')).to_sym
      headers = apitest_headers(
          args.merge(with_auth: true,
          auth_service: LocalAuthService.new))
      data = format_request(sym, args)
      variables = { input: args[:input] }
      graphql url(args), data, variables, headers, args
      expect_success_graphql
      check(sym, args)
      json_body[:data][sym]
      end

      def default_savings_plan_recommendations(args = {})
      args[:service] = SavingsPlansService.new
      sym = first_no_cap(camelize('default_savings_plan_recommendations')).to_sym
      headers = apitest_headers(
        args.merge(with_auth: true,
        auth_service: lauth_service))
      data = format_request(sym, args)
      variables = {  }
      graphql url(args), data, variables, headers, args
      expect_success_graphql
      check(sym, args)
      json_body[:data][sym]
      end

    def update_sp_saved_recommendation(args = {})
      args[:service] = SavingsPlansService.new
      sym = first_no_cap(camelize('update_sp_saved_recommendation')).to_sym
      headers = apitest_headers(
          args.merge(with_auth: true,
                     auth_service: lauth_service))
      data = format_request(sym, args)
      variables = { input: args[:input] }
      graphql url(args), data, variables, headers, args
      expect_success_graphql
      check(sym, args)
      json_body[:data][sym]
    end

    def savings_plan_recommendations(args = {})
      args[:service] = SavingsPlansService.new
      sym = first_no_cap(camelize('savings_plan_recommendations')).to_sym
      headers = apitest_headers(
        args.merge(with_auth: true, auth_service: lauth_service))
      data = format_request(sym, args)
      variables = {
        options: {
          awsBillingAccountId: args[:awsBillingAccountId],
          considerExpiringUsage: args[:considerExpiringUsage],
          evaluationPeriod: args[:evaluationPeriod],
          overrideConfiguration: {
            overrideHourlyCommitment: args[:overrideHourlyCommitment],
            overrideTotalCoverage: args[:overrideTotalCoverage],
            overrideType: args[:overrideType]
          }
        }
      }
      graphql url(args), data, variables, headers, args
      expect_success_graphql
      check(sym, args)
      json_body[:data][sym]
    end

    def savings_plan_simulation(args = {})
      args[:service] = SavingsPlansService.new
      sym = first_no_cap(camelize('savings_plan_simulation')).to_sym
      headers = apitest_headers(args.merge(with_auth: true, auth_service: lauth_service))
      data = format_request(sym, args)
      variables = {
        options: {
          awsBillingAccountId: args[:awsBillingAccountId],
          considerExpiringUsage: args[:considerExpiringUsage],
          evaluationPeriod: args[:evaluationPeriod],
          hourlyCommitment: args[:hourlyCommitment],
          offeringType: args[:offeringType],
          simulationId: args[:simulationId],
          term: args[:term],
          type: args[:type]
        }
      }
      graphql url(args), data, variables, headers, args
      expect_success_graphql
      check(sym, args)
      json_body[:data][sym]
    end

    def sp_saved_simulation(args = {})
      args[:service] = SavingsPlansService.new
      sym = first_no_cap(camelize('sp_saved_simulation')).to_sym
      headers = apitest_headers(
          args.merge(with_auth: true,
                     auth_service: lauth_service))
      data = format_request(sym, args)
      variables = { 
        override: {
          overrideHourlyCommitment: args[:overrideHourlyCommitment],
          overrideTotalCoverage: args[:overrideTotalCoverage],
          overrideType: args[:overrideType] },
        recommendationId: args[:recommendationId] }
      graphql url(args), data, variables, headers, args
      expect_success_graphql
      check(sym, args)
      json_body[:data][sym]
    end


    def available_billing_accounts(args = {})
      args[:service] = SavingsPlansService.new
      sym = first_no_cap(camelize('available_billing_accounts')).to_sym
      headers = apitest_headers(
          args.merge(with_auth: true,
                     auth_service: lauth_service))
      data = format_request(sym, args)
      variables = {  }
      graphql url(args), data, variables, headers, args
      expect_success_graphql
      check(sym, args)
      json_body[:data][sym]
    end

    def available_accounts(args = {})
      args[:service] = SavingsPlansService.new
      sym = first_no_cap(camelize('available_accounts')).to_sym
      headers = apitest_headers(
          args.merge(with_auth: true,
                     auth_service: lauth_service))
      data = format_request(sym, args)
      variables = {  }
      graphql url(args), data, variables, headers, args
      expect_success_graphql
      check(sym, args)
      json_body[:data][sym]
    end

    def sp_saved_recommendations(args = {})
      args[:service] = SavingsPlansService.new
      sym = first_no_cap(camelize('sp_saved_recommendations')).to_sym
      headers = apitest_headers(
          args.merge(with_auth: true,
                     auth_service: lauth_service))
      data = format_request(sym, args)
      variables = { filters: args[:filters], ids: args[:ids] }
      graphql url(args), data, variables, headers, args
      expect_success_graphql
      check(sym, args)
      json_body[:data][sym]
    end

    def delete_sp_saved_recommendation(args = {})
      args[:service] = SavingsPlansService.new
      sym = first_no_cap(camelize('delete_sp_saved_recommendation')).to_sym
      headers = apitest_headers(
          args.merge(with_auth: true,
                     auth_service: lauth_service))
      data = format_request(sym, args)
      variables = { recommendationId: args[:recommendationId] }
      graphql url(args), data, variables, headers, args
      expect_success_graphql
      check(sym, args)
      json_body[:data][sym]
    end

    def refresh_sp_saved_recommendation(args = {})
      args[:service] = SavingsPlansService.new
      sym = first_no_cap(camelize('refresh_sp_saved_recommendation')).to_sym
      headers = apitest_headers(
          args.merge(with_auth: true,
                     auth_service: lauth_service))
      data = format_request(sym, args)
      variables = { recommendationId: args[:recommendationId] }
      graphql url(args), data, variables, headers, args
      expect_success_graphql
      check(sym, args)
      json_body[:data][sym]
    end

    # end of shortcut insertion
  end

  # class for your service
  class SavingsPlansService < ChtNgService
    include RSpec::Matchers

    SAVINGS_PLANS_DEFAULTS = {
      name: 'SavingsPlans',
      default_namespace: 'savings-plans',
      service_name: 'savings-plans',
      pr_parent: 'savings-plans',
      formatters: SAVINGS_PLANS_FMTRS['formatters'],
      v2_checkers: SAVINGS_PLANS_FMTRS['v2_checkers']
    }.freeze
    def initialize(args = {})
      super(args.merge(SAVINGS_PLANS_DEFAULTS))
    end
  end

  # class for api-proxy support of savings-plans service
  class ApiProxySavingsPlans < ChtNgService
    include RSpec::Matchers

    API_PROXY_DEFAULTS = {
      name: 'ApiProxySavingsPlans',
      default_namespace: 'api-proxy',
      service_name: 'api-proxy',
      pr_parent: 'api-proxy',
      formatters: SAVINGS_PLANS_FMTRS['formatters'],
      v2_checkers: SAVINGS_PLANS_FMTRS['v2_checkers']
    }.freeze
    def initialize(args = {})
      super(args.merge(API_PROXY_DEFAULTS))
    end
  end
end
