require 'spec_helper'

module SavingsPlansTest
  describe 'SavingsPlans availableBillingAccounts route' do
    include_context 'request metadata'
    it 'returns all expected objects as per schema' do
      variables = {}
      get_api_response(variables, headers, :availableBillingAccounts)
      check(:availableBillingAccounts, service: service)
    end

    it 'returns all expected account information' do
      variables = {}
      get_api_response(variables, headers, :availableBillingAccounts)
      account_node = json_body[:data][:availableBillingAccounts][:edges]
      expect(account_node.length).to eq(1)
      expect(account_node[0][:node][:id]).to eq(TEST_DATA_ENV == 'preprod' ? TEST_CUSTOMER_PREPROD[:aws_billing_id] : TEST_CUSTOMER[:aws_billing_id])
      expect(account_node[0][:node][:name]).to eq(TEST_DATA_ENV == 'preprod' ? TEST_CUSTOMER_PREPROD[:name] : TEST_CUSTOMER[:name])
      expect(account_node[0][:node][:ownerId]).to eq(TEST_DATA_ENV == 'preprod' ? TEST_CUSTOMER_PREPROD[:owner_id] : TEST_CUSTOMER[:owner_id])
    end

    # Expecting 500 pending resolution of https://cloudhealthtech.atlassian.net/browse/ENG-22612
    it 'returns expected error for no auth request' do
      wrap_request do
        variables = {
        }
        graphql url(service: service),
                format_request(
                  :availableBillingAccounts,
                  service: service
                ),
                variables, apitest_headers
        expect_status(403)
        expect(json_body[:data]).to be_nil
        expect(json_body[:error]).to_not be_nil
      end
    end
  end
end
