require 'spec_helper'

module SavingsPlansTest
  variables = {}

  describe 'defaultSavingsPlanRecommendations route introspection based test ' do
    include_context 'request metadata'
    it 'route returns all expected objects as per schema' do
      variables = {}
      get_api_response(variables, headers, :defaultSavingsPlanRecommendations)
      expect_success_graphql
      check(:defaultSavingsPlanRecommendations, service: service)
    end
  end

  describe 'defaultSavingsPlanRecommendations route: standard reservation tests pass: ' do
    include_examples 'standard reservation array tests', variables, :defaultSavingsPlanRecommendations

    include_examples 'recommendation summary tests', variables, :defaultSavingsPlanRecommendations
  end

  describe 'defaultSavingsPlanRecommendations route: standard options node tests pass: ' do
    include_context 'request metadata'
    include_examples 'standard savings plan options node tests', variables, :defaultSavingsPlanRecommendations
  end


  describe 'For defaultSavingsPlanRecommendations route negative tests' do
    include_context 'request metadata'

    # Expecting 500 pending resolution of https://cloudhealthtech.atlassian.net/browse/ENG-22612
    it 'route returns expected error for no auth request' do
      variables = {
      }
      graphql url(service: service),
              format_request(
                  :availableBillingAccounts,
                  service: service
              ),
              variables, apitest_headers
      expect_status(403)
      expect(json_body[:data]).to be_nil
      expect(json_body[:error]).to_not be_nil
    end

  end
end
